﻿using System;
using RivestSoft;

namespace RivestSoftSsoTest
{
    class Test
    {
        static void Main(string[] args)
        {
            string ssoToken;

            /////////////////////////////////////////////
            /// 토큰 발행
            /////////////////////////////////////////////
            do
            {
                // SSO 객체 생성
                SSO sso = new SSO();

                // 사용자의 기본 인적사항 [필수]
                sso.setUserId("홍길동");
                sso.setClientIp("192.168.0.2");

                // 사용자의 부가적인 인적사항 [옵션]
                sso.setProfile("userName", "홍길동");
                sso.setProfile("deptCode", "A1000");
                sso.setProfile("deptName", "조선시대 의적");
                sso.setProfile("handphone", "010-0000-0000");
                sso.setProfile("email", "rivestsoft@gmail.com");
                sso.setProfile("age", "20");
                sso.setProfile("birth", "19901215");

                // SSO Server의 IP와 PORT 설정 [옵션]
                sso.setServerIp("localhost");
                sso.setServerPort((short)8420);

                // 토큰 발행 요청
                sso.issueToken();

                // 에러체크
                if (sso.getError() < 0)
                {
                    Console.WriteLine("에러발생 : " + sso.getError());
                    return;
                }

                ssoToken = sso.getToken();
                Console.WriteLine("발급받은 토큰 : " + ssoToken);
            } while (false);

            /////////////////////////////////////////////
            /// 토큰 검증
            /////////////////////////////////////////////
            do
            {
                // SSO 객체 생성
                SSO sso = new SSO();

                // 토큰 검증 요청시 필수값
                sso.setToken(ssoToken);
                sso.setClientIp("192.168.0.2");

                // SSO Agent의 PORT 설정 [옵션]
                sso.setAgentPort((short)8421);

                // 토큰 검증 요청
                sso.verifyToken();

                // 에러체크
                if (sso.getError() != 0)
                {
                    Console.WriteLine("에러발생 : " + sso.getError());
                    return;
                }

                // 사용자 정보
                Console.WriteLine("userId : " + sso.getUserId());
                Console.WriteLine("userName : " + sso.getProfile("userName"));
                Console.WriteLine("age : " + sso.getProfile("age"));
            } while (false);
        }
    }
}
